on run {thePlaylist, thePlayer, theSubName, theMode, theQuit, theGoPath}
	set theFlg to "1"
	tell application "Finder"
		set theDiskAll to every disk
		repeat with theDiskTmp in theDiskAll
			if not startup of theDiskTmp then
				if local volume of theDiskTmp then
					--if ejectable of theDisk then
					if name of theDiskTmp is thePlayer then
						set theDisk to theDiskTmp
						set theFlg to "0"
						exit repeat
					end if
					--end if
				end if
			end if
		end repeat
		if theFlg is "1" then
			return theFlg
		else
			if theSubName is "" then
				set theSubPath to thePlayer
			else
				if (exists of folder theSubName of theDisk) is true then
					do shell script "rm -r -f /Volumes/'" & thePlayer & "'/'" & theSubName & "'"
				end if
				make new folder at theDisk with properties {name:theSubName}
				set theList to {thePlayer}
				set theList to theList & ":" & theSubName
				set theSubPath to theList as string
			end if
			set theFolder to folder theSubPath
		end if
		repeat
			if (exists of folder theSubName of theDisk) is true then
				exit repeat
			end if
		end repeat
	end tell
	tell application "iTunes"
		if (exists of user playlist thePlaylist) is false then
			return "2"
		end if
		set theTrack to every track of user playlist thePlaylist
		repeat with idx from 1 to (count of theTrack)
			tell application "System Events"
				set theGoFlg to exists file theGoPath
			end tell
			if theGoFlg is true then
				set theCheck to enabled of item idx of theTrack
				if theCheck is true then
					set thePath to location of item idx of theTrack
					tell application "Finder"
						set theSpace to get free space of theDisk
						set theFile to file thePath
						set theSize to size of theFile
						if theSpace > theSize then
							set theExtn to name extension of theFile
							if theExtn is "mp3" then
								duplicate theFile to theFolder with replacing
							end if
						else
							set theFlg to "3"
							exit repeat
						end if
					end tell
				end if
			else
				set theFlg to "4"
				exit repeat
			end if
		end repeat
		if theQuit is "true" then
			quit
		end if
	end tell
	if theMode is "auto" then
		tell application "Finder"
			eject disk thePlayer
		end tell
		if theFlg is "3" then
			set theFlg to "103"
		else if theFlg is "4" then
			set theFlg to "104"
		else
			set theFlg to "100"
		end if
	end if
	set theResult to theFlg
end run
