/************************************************/
// send (MP3 file to) Flash Memory audio Player
/************************************************/

var tempPL;
var tempPR;
var tempSS;
var tempSN;
var tempAE;
var sendCmd;
var sendFl = "jp_greif_sendfmp";
var sendGo = "/tmp/" + sendFl + "/go.txt";


function init()
{
	if (window.widget)	// always check to make sure that you are running in Dashboard
	{
		createGenericButton(document.getElementById("getLButton"),"Get",setPopupL);
		createGenericButton(document.getElementById("getVButton"),"Get",setPopupV);
		createGenericButton(document.getElementById("doneButton"),"Done",hidePrefs);

		widget.onshow = onshow;
		widget.onhide = onhide;
		widget.onremove = onremove;
	}
}

function onshow()
{
	tempPL = widget.preferenceForKey("tempPL");
	tempPR = widget.preferenceForKey("tempPR");
	tempSS = widget.preferenceForKey("tempSS");
	tempSN = widget.preferenceForKey("tempSN");
	tempAE = widget.preferenceForKey("tempAE");
	document.getElementById("PlayListName").innerHTML = tempPL;
	document.getElementById("volumeName").innerHTML = tempPR;
	if (tempSS == null) tempSS = true;
	document.getElementById("checkSname").checked = tempSS;
	if (tempSN == null) tempSN = "music";
	document.getElementById("inputText").value = tempSN;
	if (tempAE == null) tempAE = false;
	document.getElementById("checkAuto").checked = tempAE;

	if (tempAE == true && document.getElementById("msgText2").innerHTML == "") sendFile2();
}

function onhide()
{
	if (tempPL != null) widget.setPreferenceForKey(document.getElementById("PlayListName").innerHTML,"tempPL");
	if (tempPR != null) widget.setPreferenceForKey(document.getElementById("volumeName").innerHTML,"tempPR");
	widget.setPreferenceForKey(document.getElementById("checkSname").checked,"tempSS");
	widget.setPreferenceForKey(document.getElementById("inputText").value,"tempSN");
	widget.setPreferenceForKey(document.getElementById("checkAuto").checked,"tempAE");
}

function onremove()
{
	widget.setPreferenceForKey(null,"tempPL");
	widget.setPreferenceForKey(null,"tempPR");
	widget.setPreferenceForKey(null,"tempSS");
	widget.setPreferenceForKey(null,"tempSN");
	widget.setPreferenceForKey(null,"tempAE");
}


function sendFile()
{
	document.getElementById("doButton").src = "Images/Button_down.png";
	sendFile2();	
}

function sendFile2()
{
	if (document.getElementById("doButtonText").innerHTML == "Send")
	{
		if (tempPL == null || tempPL == "") showMsg("msgText","プレイリストが選択されていません。");
		else if (tempPR == null || tempPR == "") showMsg("msgText","プレーヤーが選択されていません。");
		else SendFile3();
	}
	else if (document.getElementById("doButtonText").innerHTML == "Stop")
	{
		widget.system('/bin/rm -f '+sendGo,null);
		document.getElementById("doButtonText").innerHTML = "";
		document.getElementById("msgText2").innerHTML = "中止処理中 ...";
	}
}

function SendFile3()
{
	var rcode = widget.system('/usr/bin/osascript AppleScripts/chkDisk.applescript "'+tempPR+'"',null).outputString;
	if (parseInt(rcode) != 1)
	{
		showMsg("msgText","プレーヤーが見つかりません。");
		return;
	}
	var mdrFlg = widget.system('/bin/ls /tmp | /usr/bin/grep '+sendFl,null).outputString;
	if (mdrFlg == null) widget.system('/bin/mkdir /tmp/'+sendFl,null);
	widget.system('/usr/bin/touch '+sendGo,null);
	document.getElementById("doButtonText").innerHTML = "Stop";
	document.getElementById("msgText2").innerHTML = "転送中 ...";
	tempSS = document.getElementById("checkSname").checked;
	tempSN = document.getElementById("inputText").value;
	tempAE = document.getElementById("checkAuto").checked;
	var tempSNs=tempSN;
	if (tempSS == false) tempSNs="";
	var tempAEs="manual";
	if (tempAE == true) tempAEs="auto";
	var quitFlg = widget.system('/usr/bin/osascript AppleScripts/chkiTunes.applescript',null).outputString;
	var quitSt = "false";
	if (parseInt(quitFlg) == 1) quitSt = "true";
	sendCmd = widget.system('/usr/bin/osascript AppleScripts/sendFile.applescript "'+tempPL+'" "'+tempPR+'" "'+tempSNs+'" "'+tempAEs+'" "'+quitSt+'" "'+sendGo+'"',SendFile4);
}

function SendFile4()
{
	document.getElementById("doButtonText").innerHTML = "Send";
	document.getElementById("msgText2").innerHTML = "";
	var abortFlg = false;
	switch (parseInt(sendCmd.outputString))
	{
		case 0:
			showMsg("msgText","正常に転送されました。");
			break;
		case 100:
			showMsg("msgText","正常に転送されました。<BR>プレーヤーをイジェクトしました。");
			break;
		case 1:
			showMsg("msgText","プレーヤーが見つかりません。");
			break;
		case 2:
			showMsg("msgText","プレイリストが見つかりません。");
			break;
		case 3:
			showMsg("msgText","プレーヤーの容量不足で、転送を中止しました。");
			break;
		case 103:
			showMsg("msgText","プレーヤーの容量不足で、転送を中止しました。<BR>プレーヤーをイジェクトしました。");
			break;
		case 4:
			showMsg("msgText","Stopボタンが押されたので、転送を中止しました。");
			var abortFlg = true;
			break;
		case 104:
			showMsg("msgText","Stopボタンが押されたので、転送を中止しました。<BR>プレーヤーをイジェクトしました。");
			var abortFlg = true;
			break;
		default:
			showMsg("msgText","予期しないエラーが発生しました。("+rcode+")");
			break;
	}
	sendCmd = null;
	if (abortFlg == false) widget.system('/bin/rm -f '+sendGo,null);
}

function playlsChanged(select)
{
	if (tempPL != select.options[select.selectedIndex].text)
	{
		tempPL = select.options[select.selectedIndex].text;
		document.getElementById("PlayListName").innerHTML = tempPL;
	}
}

function volumeChanged(select)
{
	if (tempPR != select.options[select.selectedIndex].text)
	{
		tempPR = select.options[select.selectedIndex].text;
		document.getElementById("volumeName").innerHTML = tempPR;
	}
}

function setPopupL()
{
	var quitFlg = widget.system('/usr/bin/osascript AppleScripts/chkiTunes.applescript',null).outputString;
	var quitSt = "false";
	if (parseInt(quitFlg) == 1) quitSt = "true";
	var output = widget.system('/usr/bin/osascript AppleScripts/getPlaylist.applescript "'+quitSt+'"',null).outputString;
	document.getElementById("tempText").innerHTML = output;
	var st_array = document.getElementById("tempText").innerHTML.split(";")
	var select = document.getElementById ('playls-popup');
	var pos = 0;
	var c = select.length;
	for (var i = c; i >= 0; i--)
	{
		select.options[i]=null;
	}
	c = st_array.length - 1;
	for (var i = 0; i < c; ++i)
	{
		var element = document.createElement("option");
		element.innerText = st_array[i];
		select.appendChild(element);
		if (st_array[i] == tempPL) pos=i;
	}
	select.selectedIndex=pos;
	playlsChanged(select);
}

function setPopupV()
{
	var output = widget.system('/usr/bin/osascript AppleScripts/getDisk.applescript',null).outputString;
	document.getElementById("tempText").innerHTML = output;
	var st_array = document.getElementById("tempText").innerHTML.split(";")
	if (st_array.length <= 1)
	{
		showMsg("msgTextR","プレーヤーが見つかりません。");
		return;
	}
	var select = document.getElementById ('volume-popup');
	var pos = 0;
	var c = select.length;
	for (var i = c; i >= 0; i--)
	{
		select.options[i]=null;
	}
	c = st_array.length - 1;
	for (i = 0; i < c; ++i)
	{
		var element = document.createElement("option");
		element.innerText = st_array[i];
		select.appendChild(element);
		if (st_array[i] == tempPR) pos=i;
	}
	select.selectedIndex=pos;
	volumeChanged(select);
}

function showMsg(element,mes)
{
	document.getElementById(element).innerHTML = mes;
	textFadeout(element);
}

function showReadme()
{
	widget.system("/usr/bin/open sendFMP.rtf",null);
}

// When the action button is clicked upon or clicked on, moused out, and moused up,
// it needs to be replaced by the unactive version of the button.

function buttonUpOut()
{
	document.getElementById("doButton").src = "Images/Button.png";
}

/*********************************/
// FADEOUT INFOMATION-MESSAGE
/*********************************/

// A structure that holds information that is needed for the animation to run.
var animation2 = {duration:0, starttime:0, to:1.0, now:1.0, from:0.0, firstElement:null, timer:null};

function textFadeout(element)
{
		// fade in the flip widget
		if (animation2.timer != null)
		{
			clearInterval (animation2.timer);
			animation2.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation2.duration = 2000;
		animation2.starttime = starttime;
		animation2.firstElement = document.getElementById (element);
		animation2.timer = setInterval ("animate2();", 13);
		animation2.from = 1.0;
		animation2.to = 0.0;
		animate2();

}

function animate2()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation2.starttime, 0, animation2.duration);
	
	if (T >= animation2.duration)
	{
		clearInterval (animation2.timer);
		animation2.timer = null;
		animation2.now = animation2.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation2.duration));
		animation2.now = computeNextFloat (animation2.from, animation2.to, ease);
	}
	
	animation2.firstElement.style.opacity = animation2.now;
}

/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");	// freezes the widget so that you can change it without the user noticing
	
	front.style.display = "none";	// hide the front
	back.style.display = "block";	// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';	// clean up the front side - hide the circle behind the info button
}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");	// freezes the widget and prepares it for the flip back to the front
	
	back.style.display = "none";		// hide the back
	front.style.display = "block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	// and flip the widget back to the front


	//document.getElementById("PlayListName").innerHTML = document.getElementById("playls-popup").options[document.getElementById("playls-popup").selectedIndex].text;
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)	// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)	// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;		// set it back one frame
		
		animation.duration = 500;					// animation time, in ms
		animation.starttime = starttime;				// specify the start time
		animation.firstElement = document.getElementById ('flip');	// specify the element to fade
		animation.timer = setInterval ("animate();", 13);		// set the animation function
		animation.from = animation.now;					// beginning opacity (not ness. 0)
		animation.to = 1.0;						// final opacity
		animate();							// begin animation
		flipShown = true;						// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}
